## choreonoid-2.3.0.zip

=== CMakeLists.txt ===
if(MSVC)
  # Version 3.13 or later is required because the following features are used in this project.
  # * CMAKE_CXX_STANDARD 17 is supported for MSVC since version 3.10
  # * The target_link_options command is available since version 3.13
  # * The install command can specifiy a target defined in a sub directory since version 3.13
  cmake_minimum_required(VERSION 3.13)
else()
  # CMake version 3.10.2 is installed in Ubuntu 18.04.
  cmake_minimum_required(VERSION 3.10)
endif()

cmake_policy(SET CMP0003 NEW)
cmake_policy(SET CMP0057 NEW)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

include(FindPkgConfig)
include(CheckIncludeFiles)
include(CheckCXXCompilerFlag)

project(Choreonoid)

# set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/)
set(CHOREONOID_VERSION_MAJOR 2)
set(CHOREONOID_VERSION_MINOR 3)
set(CHOREONOID_VERSION_PATCH 0)
set(CHOREONOID_VERSION ${CHOREONOID_VERSION_MAJOR}.${CHOREONOID_VERSION_MINOR})
set(CHOREONOID_VERSION_STRING ${CHOREONOID_VERSION}.${CHOREONOID_VERSION_PATCH})
set(CHOREONOID_VERSION_ID "0x020300")
set(CHOREONOID_INTERNAL_VERSION 5)

# Use GNUInstallDirs for standard directory variables (supports multiarch)
include(GNUInstallDirs)

set(CHOREONOID_VERSION_SUBDIR choreonoid-${CHOREONOID_VERSION})
set(CHOREONOID_BIN_SUBDIR ${CMAKE_INSTALL_BINDIR})
set(CHOREONOID_LIB_SUBDIR ${CMAKE_INSTALL_LIBDIR})
set(CHOREONOID_PLUGIN_SUBDIR ${CMAKE_INSTALL_LIBDIR}/${CHOREONOID_VERSION_SUBDIR})
set(CHOREONOID_HEADER_SUBDIR ${CMAKE_INSTALL_INCLUDEDIR})
set(CHOREONOID_SHARE_SUBDIR ${CMAKE_INSTALL_DATADIR})
set(CHOREONOID_DOC_SUBDIR ${CMAKE_INSTALL_DATADIR}/doc)

set(CHOREONOID_CMAKE_CONFIG_SUBDIR share/choreonoid/cmake) # ROS compliant
#set(CHOREONOID_CMAKE_CONFIG_SUBDIR lib/choreonoid-${CNOID_VERSION}/cmake)

if(UNIX)
  set(CHOREONOID_HEADER_SUBDIR ${CHOREONOID_HEADER_SUBDIR}/${CHOREONOID_VERSION_SUBDIR})
  set(CHOREONOID_SHARE_SUBDIR ${CHOREONOID_SHARE_SUBDIR}/${CHOREONOID_VERSION_SUBDIR})
  set(CHOREONOID_DOC_SUBDIR ${CHOREONOID_DOC_SUBDIR}/${CHOREONOID_VERSION_SUBDIR})
endif()

set(CHOREONOID_SHARE_DIR ${CMAKE_INSTALL_PREFIX}/${CHOREONOID_SHARE_SUBDIR})
set(CHOREONOID_SOURCE_SHARE_DIR ${PROJECT_SOURCE_DIR}/share)

if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
  set(CHOREONOID_BINARY_SHARE_DIR ${CHOREONOID_SOURCE_SHARE_DIR})
else()
  set(CHOREONOID_BINARY_SHARE_DIR ${PROJECT_BINARY_DIR}/${CHOREONOID_SHARE_SUBDIR})
endif()

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

if(WIN32)
  set(DEFAULT_INSTALL_SDK OFF)
  set(DEFAULT_INSTALL_RUNTIME_DEPENDENCIES ON)
else()
  set(DEFAULT_INSTALL_SDK ON)
  set(DEFAULT_INSTALL_RUNTIME_DEPENDENCIES OFF)
endif()

option(INSTALL_RUNTIME_DEPENDENCIES "Installing the runtimes of external libraries" ${DEFAULT_INSTALL_RUNTIME_DEPENDENCIES})
option(INSTALL_SDK "Installing SDK files such as header files" ${DEFAULT_INSTALL_SDK})
set(CHOREONOID_INSTALL_SDK ${INSTALL_SDK})
set(CHOREONOID_SDK_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/${CHOREONOID_HEADER_SUBDIR})
set(CHOREONOID_SDK_LIBRARY_DIRS
  ${CMAKE_INSTALL_PREFIX}/${CHOREONOID_LIB_SUBDIR} ${CMAKE_INSTALL_PREFIX}/${CHOREONOID_PLUGIN_SUBDIR})

# Deprecated
set(CNOID_MAJOR_VERSION ${CHOREONOID_VERSION_MAJOR})
set(CNOID_MINOR_VERSION ${CHOREONOID_VERSION_MINOR})
set(CNOID_PATCH_VERSION ${CHOREONOID_VERSION_PATCH})
set(CNOID_VERSION ${CHOREONOID_VERSION})
set(CNOID_FULL_VERSION ${CHOREONOID_VERSION_STRING})
set(CNOID_VERSION_ID ${CHOREONOID_VERSION_ID})
set(CNOID_INTERNAL_VERSION ${CHOREONOID_INTERNAL_VERSION})
set(CNOID_VERSION_SUBDIR ${CHOREONOID_VERSION_SUBDIR})
set(CNOID_PLUGIN_SUBDIR ${CHOREONOID_PLUGIN_SUBDIR})
set(CNOID_HEADER_SUBDIR ${CHOREONOID_HEADER_SUBDIR})
set(CNOID_SHARE_SUBDIR ${CHOREONOID_SHARE_SUBDIR})
set(CNOID_DOC_SUBDIR ${CHOREONOID_DOC_SUBDIR})
set(CNOID_SHARE_DIR ${CHOREONOID_SHARE_DIR})
set(CNOID_SOURCE_SHARE_DIR ${CHOREONOID_SOURCE_SHARE_DIR})
set(CNOID_BINARY_SHARE_DIR ${CHOREONOID_BINARY_SHARE_DIR})

set(CMAKE_CXX_EXTENSIONS OFF)

# C++ version
if(CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD ${CMAKE_CXX_STANDARD} CACHE STRING "C++ version number. Specify either 20, 17 or 14.")

else()
  set(cxx_standard 14)

  if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.12.0) # C++20 is supported by CMake 3.12 or later
    if(UNIX)
      check_cxx_compiler_flag("-std=c++20" has_cpp20)
    elseif(MSVC)
      check_cxx_compiler_flag("/std:c++20" has_cpp20)
    endif()
    if(has_cpp20)
      set(cxx_standard 20)
    endif()
  endif()

  if(NOT has_cpp20)
    if(UNIX)
      # C++17 support of GCC 7 is experimental
      if(NOT CMAKE_COMPILER_IS_GNUCC OR CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 8)
	check_cxx_compiler_flag("-std=c++17" has_cpp17)
      endif()
    elseif(MSVC)
      check_cxx_compiler_flag("/std:c++17" has_cpp17)
    endif()
    if(has_cpp17)
      set(cxx_standard 17)
    endif()
  endif()

  set(CMAKE_CXX_STANDARD ${cxx_standard} CACHE STRING "C++ version number. Specify either 20, 17 or 14.")
endif()

if(CMAKE_CXX_STANDARD LESS 14)
  message(FATAL_ERROR "Choreonoid requires C++14 or higher.")
endif()

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCC)
    # To allow for reloading a controller shared library
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --no-gnu-unique")
  endif()
  add_definitions("-pthread")

elseif(MSVC)
  if(${MSVC_VERSION} GREATER_EQUAL 1910)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
  endif()
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(
    CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
endif()

set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS $<$<CONFIG:Debug>:CNOID_DEBUG>)

if(UNIX)
  set(CHOREONOID_DEFAULT_FVISIBILITY_HIDDEN ON)

  set(compiler_general_options "-Wreturn-type")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -finline-functions")

  option(ENABLE_NATIVE_CPU_ARCHITECTURE "Use the -march=native option to enable instruction set supported by the native processor architecture" OFF)
  if(ENABLE_NATIVE_CPU_ARCHITECTURE)
    set(compiler_general_options "${compiler_general_options} -march=native")
  endif()

  option(CHECK_UNRESOLVED_SYMBOLS "check unresolved symbols in the object files when creating shared libraries" OFF)
  if(CHECK_UNRESOLVED_SYMBOLS)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--unresolved-symbols=ignore-in-shared-libs -Wl,--warn-unresolved-symbols")
  endif()

  option(PUT_EXTRA_WARNINGS "Put extra warnings in compile" OFF)
  if(PUT_EXTRA_WARNINGS)
    set(compiler_general_options "${compiler_general_options} -Wall -Wunused -Woverloaded-virtual -Wsign-compare")
    # -Wparentheses -Wformat=2 -Wformat-nonliteral -Wunknown-pragmas -Wunused-parameter -Wuninitialized -Winit-self -pedantic -Wconversion -Wno-variadic-macros -Wno-long-long -Wno-import -Wno-missing-braces
  endif()

  option(ENABLE_LTO "Enable Link Time Optimization (LTO)" OFF)
  if(ENABLE_LTO)
    # Check what LTO flags are already set (e.g., by dpkg-buildflags)
    set(needs_lto_flags TRUE)
    if(CMAKE_CXX_FLAGS_RELEASE MATCHES "-flto=thin" OR CMAKE_CXX_FLAGS_RELWITHDEBINFO MATCHES "-flto=thin")
      message(STATUS "LTO already enabled with -flto=thin")
      set(needs_lto_flags FALSE)
    elseif(CMAKE_CXX_FLAGS_RELEASE MATCHES "-flto=auto" OR CMAKE_CXX_FLAGS_RELWITHDEBINFO MATCHES "-flto=auto")
      if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        # Replace -flto=auto with -flto=thin for Clang
        string(REPLACE "-flto=auto" "-flto=thin" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
        string(REPLACE "-flto=auto" "-flto=thin" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
        message(STATUS "Replaced -flto=auto with -flto=thin for Clang")
      else()
        message(STATUS "LTO already enabled with -flto=auto")
      endif()
      set(needs_lto_flags FALSE)
    elseif(CMAKE_CXX_FLAGS_RELEASE MATCHES "-flto" OR CMAKE_CXX_FLAGS_RELWITHDEBINFO MATCHES "-flto")
      # Basic -flto is set, upgrade to more specific version
      if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        string(REPLACE "-flto" "-flto=thin" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
        string(REPLACE "-flto" "-flto=thin" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
        message(STATUS "Upgraded -flto to -flto=thin for Clang")
      else()
        string(REPLACE "-flto" "-flto=auto" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
        string(REPLACE "-flto" "-flto=auto" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
        message(STATUS "Upgraded -flto to -flto=auto for GCC")
      endif()
      set(needs_lto_flags FALSE)
    endif()
    
    if(needs_lto_flags)
      if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set(lto_flags "-flto=thin")
      else()
        # GCC or other compilers
        set(lto_flags "-flto=auto")
      endif()
      # Add to compiler options only - CMake will automatically use them for linking too
      set(compiler_release_options "${compiler_release_options} ${lto_flags}")
      message(STATUS "LTO enabled with ${lto_flags}")
    endif()
  endif()
endif()

if(MSVC)
  set(CHOREONOID_DEFAULT_FVISIBILITY_HIDDEN OFF)
  set(compiler_general_options "/MP /bigobj /wd4018 /wd4068 /wd4244 /wd4250 /wd4251 /wd4267 /wd4275 /wd4800 /wd4819")
  set(compiler_release_options "/O2 /Ob2 /Oi /Gy /GS- /fp:fast")

  if(${MSVC_VERSION} GREATER_EQUAL 1915)
    add_definitions(-D_ENABLE_EXTENDED_ALIGNED_STORAGE)
  endif()
  if(CMAKE_CXX_STANDARD GREATER_EQUAL 17)
    option(DISABLE_CXX17_DEPRECATION_WARNINGS "Define _SILENCE_ALL_CXX17_DEPRECATION_WARNINGS" ON)
    mark_as_advanced(DISABLE_CXX17_DEPRECATION_WARNINGS)
    if(DISABLE_CXX17_DEPRECATION_WARNINGS)
      add_definitions(-D_SILENCE_ALL_CXX17_DEPRECATION_WARNINGS)
    endif()
  endif()

  if(CMAKE_CL_64)
    add_definitions(-D_WIN64)
    option(ENABLE_MSVC_AVX "Enable AVX instructions on VC++." ON)
    option(ENABLE_MSVC_AVX2 "Enable AVX2 instructions on VC++." ON)
    if(ENABLE_MSVC_AVX2)
      set(compiler_general_options "${compiler_general_options} /arch:AVX2")
    elseif(ENABLE_MSVC_AVX)
      set(compiler_general_options "${compiler_general_options} /arch:AVX")
    endif()
  else()
    option(ENABLE_MSVC_SSE "Enable SSE instructions" ON)
    if(ENABLE_MSVC_SSE)
      set(compiler_general_options "${compiler_general_options} /arch:SSE /arch:SSE2")
    endif()
  endif()

  set(linker_release_options "")
  option(ENABLE_MSVC_GLOBAL_OPTIMIZATION "Global optimization with compiler option /GL and linker option /LTCG" OFF)
  if(ENABLE_MSVC_GLOBAL_OPTIMIZATION)
    set(compiler_release_options "${compiler_release_options} /GL")
    set(linker_release_options "${linker_release_options} /LTCG")
  endif()

  option(ENABLE_MSVC_DEBUG_INFO_FOR_RELEASE "Enable debug information for the relase build" OFF)
  mark_as_advanced(ENABLE_MSVC_DEBUG_INFO_FOR_RELEASE)
  if(ENABLE_MSVC_DEBUG_INFO_FOR_RELEASE)
    set(compiler_release_options "${compiler_release_options} /Zi")
    set(linker_release_options "${linker_release_options} /DEBUG /OPT:REF /OPT:ICF")
  endif()

  option(USE_SUBSYSTEM_CONSOLE "Attaching a console of Windows for debugging" OFF)
  set(CHOREONOID_USE_SUBSYSTEM_CONSOLE ${USE_SUBSYSTEM_CONSOLE})

  set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS
    NOMINMAX _USE_MATH_DEFINES _CRT_SECURE_NO_WARNINGS _CRT_NONSTDC_NO_DEPRECATE)
endif()

set(ADDITIONAL_CXX_FLAGS ${ADDITIONAL_CXX_FLAGS} CACHE STRING "Additional c++ compiler optimization flags")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${compiler_general_options}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${compiler_general_options}")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${ADDITIONAL_CXX_FLAGS} ${compiler_release_options}")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${compiler_release_options}")

=== cmake/CMakeLists.txt ===
set(include_dirs ${CHOREONOID_SDK_INCLUDE_DIRS})
list(REMOVE_DUPLICATES include_dirs)

set(library_dirs ${CHOREONOID_SDK_LIBRARY_DIRS})
list(REMOVE_DUPLICATES library_dirs)

get_directory_property(compile_definitions COMPILE_DEFINITIONS)

set(modules
  ${CMAKE_CURRENT_BINARY_DIR}/ChoreonoidConfig.cmake
  ChoreonoidBasicBuildFunctions.cmake
  ChoreonoidFindQt.cmake
  )

set(util_dependencies fmt ${FILESYSTEM_LIBRARY})

if(has_boost_libs_for_util_libs)
  set(boost_version ${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION})
  set(boost_components_for_util_libs system filesystem)
endif()

if(UNIX)
  set(CHOREONOID_USE_SUBSYSTEM_CONSOLE false)
elseif(MSVC)
  if(ENABLE_GETTEXT)
    list(APPEND util_dependencies ${GETTEXT_LIBRARIES})
  endif()
endif()

if(ENABLE_PYTHON)
  list(APPEND modules ChoreonoidPythonBuildFunctions.cmake)
endif()

if(ENABLE_CORBA AND BUILD_CORBA_PLUGIN)
  set(is_corba_enabled true)
  list(APPEND modules ChoreonoidCorbaBuildFunctions.cmake)
endif()

install(FILES ${modules} DESTINATION ${CHOREONOID_CMAKE_CONFIG_SUBDIR})
if(UNIX)
  # Create symlink for backward compatibility with lowercase package name.
  # The official usage is find_package(Choreonoid) with capital 'C',
  # but this symlink allows find_package(choreonoid) to work as well.
  
  # Create symlink at build time and install it
  execute_process(
    COMMAND ${CMAKE_COMMAND} -E create_symlink
      ChoreonoidConfig.cmake
      ${CMAKE_CURRENT_BINARY_DIR}/choreonoid-config.cmake
  )
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/choreonoid-config.cmake
          DESTINATION ${CHOREONOID_CMAKE_CONFIG_SUBDIR})
endif()

configure_file(ChoreonoidConfig.cmake.in ChoreonoidConfig.cmake @ONLY)

# Generate setup scripts for environment configuration
# Only generate for non-standard installation paths where environment setup is needed
if(UNIX)
  # Don't generate setup script for standard system paths (/usr, /usr/local)
  # These locations already have PATH and library paths configured
  if(NOT CMAKE_INSTALL_PREFIX MATCHES "^/usr(/local)?$")
    configure_file(setup.bash.in ${CMAKE_CURRENT_BINARY_DIR}/setup.bash @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/setup.bash
            DESTINATION .
            PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                        GROUP_READ GROUP_EXECUTE
                        WORLD_READ WORLD_EXECUTE)
  endif()
endif()

=== doc/CMakeLists.txt ===
find_package(Doxygen)

set(target_dirs
  Util
  AISTCollisionDetector
  Body
  Base
  BodyPlugin
  ManipulatorPlugin
  MediaPlugin
  PythonPlugin
  PythonSimScriptPlugin
  )
  
unset(input_files)
set(DOXYGEN_INPUT_DIRECTORIES "")
foreach(directory ${target_dirs})
  set(abs_directory ${PROJECT_SOURCE_DIR}/src/${directory})
  set(DOXYGEN_INPUT_DIRECTORIES "${DOXYGEN_INPUT_DIRECTORIES} ${abs_directory}")
  file(GLOB files ${abs_directory}/*.h ${abs_directory}/*.cpp ${abs_directory}/*.c)
  list(APPEND input_files ${files})
endforeach()

configure_file(Doxyfile.in Doxyfile @ONLY)

set(output_dir ${CMAKE_CURRENT_BINARY_DIR}/html)
file(MAKE_DIRECTORY ${output_dir})

add_custom_command(
  OUTPUT ${output_dir}/index.html
  COMMAND doxygen
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile ${input_files}
)

add_custom_target(doc ALL DEPENDS ${output_dir}/index.html)

set_property(
  TARGET doc
  APPEND PROPERTY ADDITIONAL_CLEAN_FILES ${output_dir})

install(DIRECTORY ${output_dir} DESTINATION ${CNOID_DOC_SUBDIR})

=== ext/CMakeLists.txt ===
# @author Shin'ichiro Nakaoka

file(GLOB subdirs "*")
list(SORT subdirs)

foreach(subdir ${subdirs})
  if(NOT subdir MATCHES "\\.disabled$" AND EXISTS ${subdir}/CMakeLists.txt)
    add_subdirectory(${subdir})
  endif()
endforeach()

=== include/CMakeLists.txt ===
if(INSTALL_SDK)
  file(GLOB public_headers LIST_DIRECTORIES false "cnoid/*")
  foreach(file ${public_headers})
    install(FILES ${file} DESTINATION ${CNOID_HEADER_SUBDIR}/cnoid)
  endforeach()
  file(GLOB public_headers LIST_DIRECTORIES false "cnoid/stdx/*")
  foreach(file ${public_headers})
    install(FILES ${file} DESTINATION ${CNOID_HEADER_SUBDIR}/cnoid/stdx)
  endforeach()
endif()

=== misc/CMakeLists.txt ===
add_subdirectory(script)
add_subdirectory(pkgconfig)

=== sample/CMakeLists.txt ===
function(install_project_files)
  install(FILES ${ARGV} DESTINATION ${CNOID_SHARE_SUBDIR}/project)
  if(UNIX AND NOT CNOID_SOURCE_SHARE_DIR STREQUAL CNOID_BINARY_SHARE_DIR)
    get_filename_component(sample_dir ${CMAKE_CURRENT_SOURCE_DIR} NAME)
    foreach(file ${ARGV})
      add_custom_target(
	symlink_to_${sample_dir}_sample_${file} ALL
	COMMAND ${CMAKE_COMMAND} -E create_symlink
	${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CNOID_BINARY_SHARE_DIR}/project/${file})
    endforeach()
  endif()
endfunction()

add_subdirectory(general)
add_subdirectory(SimpleController)
add_subdirectory(SceneEffects)
add_subdirectory(PoseSeq)
add_subdirectory(HRP4C)
add_subdirectory(GRobotPlugin)
add_subdirectory(Multicopter)
add_subdirectory(AGXDynamics)
add_subdirectory(Roki)
add_subdirectory(Submersible)
add_subdirectory(CollisionHandler)
add_subdirectory(JoystickTest)
add_subdirectory(WRS2018)
add_subdirectory(customizer)
add_subdirectory(CameraEffect)

=== share/CMakeLists.txt ===
set(make_symlink false)

if(UNIX AND NOT CNOID_SOURCE_SHARE_DIR STREQUAL CNOID_BINARY_SHARE_DIR)
  set(make_symlink true)
endif()

# "default" directory
set(default_files materials.yaml)
foreach(file ${default_files})
  install(FILES default/${file} DESTINATION ${CNOID_SHARE_SUBDIR}/default)
endforeach()

if(make_symlink)
  file(MAKE_DIRECTORY ${CNOID_BINARY_SHARE_DIR}/default)
  foreach(file ${default_files})
    add_custom_target(
      symlink_to_default_${file} ALL
      COMMAND ${CMAKE_COMMAND} -E create_symlink
      ${CNOID_SOURCE_SHARE_DIR}/default/${file} ${CNOID_BINARY_SHARE_DIR}/default/${file})
  endforeach()
endif()

# Incremental build issue
if(IS_SYMLINK ${CNOID_BINARY_SHARE_DIR}/model)
  file(REMOVE ${CNOID_BINARY_SHARE_DIR}/model)
endif()

# "model" directory
if(make_symlink)
  file(MAKE_DIRECTORY ${CNOID_BINARY_SHARE_DIR}/model)
endif()
if(ENABLE_SAMPLES)
  install(DIRECTORY model DESTINATION ${CNOID_SHARE_SUBDIR})
  if(make_symlink)
    set(sample_model_dirs
      AizuSpider AizuWheel DoubleArmV7 GR001 HRP4C house JACO2 Labo1 multicopter
      PA10 RIC30 Robotiq SR1 Tank UniversalRobots WAREC1
      misc)
    foreach(dir ${sample_model_dirs})
      add_custom_target(
	symlink_to_model_${dir} ALL
	COMMAND ${CMAKE_COMMAND} -E create_symlink
	${CNOID_SOURCE_SHARE_DIR}/model/${dir} ${CNOID_BINARY_SHARE_DIR}/model/${dir})
    endforeach()
  endif()
endif()

# "project" directory
if(make_symlink)
  file(MAKE_DIRECTORY ${CNOID_BINARY_SHARE_DIR}/project)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(Util)
add_subdirectory(GLSceneRenderer)
add_subdirectory(AISTCollisionDetector)
add_subdirectory(AssimpSceneLoader)
add_subdirectory(Body)
add_subdirectory(URDFBodyLoader)
add_subdirectory(Corba)

if(ENABLE_GUI)
  add_subdirectory(Base)
  add_subdirectory(AssimpPlugin)
  add_subdirectory(BodyPlugin)
  add_subdirectory(GLVisionSimulatorPlugin)
  add_subdirectory(URDFPlugin)
  add_subdirectory(ManipulatorPlugin)
  add_subdirectory(GLCameraEffectPlugin)
  add_subdirectory(LivoxMid360Plugin)

  add_subdirectory(PoseSeqPlugin)
  add_subdirectory(BalancerPlugin)
  add_subdirectory(BodyMotionFilterPlugin)
  add_subdirectory(MocapPlugin)

  add_subdirectory(SceneEffectsPlugin)
  add_subdirectory(SceneEditPlugin)

  add_subdirectory(MediaPlugin)
  add_subdirectory(FFmpegPlugin)

  add_subdirectory(PythonPlugin)
  add_subdirectory(PythonSimScriptPlugin)

  add_subdirectory(LuaPlugin)

  add_subdirectory(ODEPlugin)
  add_subdirectory(AGXDynamicsPlugin)
  add_subdirectory(BulletPlugin)
  add_subdirectory(PhysXPlugin)
  add_subdirectory(SpringheadPlugin)
  add_subdirectory(RokiPlugin)
  add_subdirectory(MulticopterPlugin)

  add_subdirectory(CorbaPlugin)
  add_subdirectory(TrafficControlPlugin)
  add_subdirectory(FCLPlugin)
  add_subdirectory(PCLPlugin)
  add_subdirectory(CompetitionPlugin)

  add_subdirectory(Choreonoid)
endif()

=== misc/pkgconfig/CMakeLists.txt ===
set(pkgconfig_dir ${PROJECT_BINARY_DIR}/lib/pkgconfig)

if(EIGEN3_FOUND)
  set(PKGCONFIG_EIGEN_REQUIREMENT "eigen3 >= 3.2.7")
else()
  unset(PKGCONFIG_EIGEN_REQUIREMENT)
endif()

set(PKGCONFIG_QT_REQUIREMENTS "Qt5Core >= 5.2.0 Qt5Gui >= 5.2.0 Qt5OpenGL >= 5.2.0 Qt5Network >= 5.2.0")

foreach(file choreonoid-util.pc choreonoid-base.pc choreonoid-body.pc choreonoid-body-plugin.pc)
  configure_file(${file}.in ${pkgconfig_dir}/${file} @ONLY)
  if(INSTALL_SDK)
    install(FILES ${pkgconfig_dir}/${file} DESTINATION ${CHOREONOID_LIB_SUBDIR}/pkgconfig)
  endif()
endforeach()

# choreonoid.pc is replaced with choreonoid-base.pc, 
# but it is still generated for the backward compatibility
configure_file(choreonoid-base.pc.in ${pkgconfig_dir}/choreonoid.pc @ONLY)
if(INSTALL_SDK)
  install(FILES ${pkgconfig_dir}/choreonoid.pc DESTINATION ${CHOREONOID_LIB_SUBDIR}/pkgconfig)
endif()

=== misc/script/CMakeLists.txt ===
configure_file(extract-messages-initial.sh.in extract-messages-initial.sh @ONLY)
configure_file(extract-messages.sh.in extract-messages.sh @ONLY)
configure_file(make_header_public.rb.in make_header_public.rb @ONLY)
configure_file(make_binary_package.sh.template make_binary_package.sh @ONLY)
configure_file(make_src_archive.sh.in make_src_archive.sh @ONLY)

if(WIN32)
  configure_file(install_win32_deps.rb.template install_win32_deps.rb)
endif()

if(UNIX)
  option(INSTALL_SYNC_LOGFILE_COMMAND "Installing the choreonoid-sync-logfile command" OFF)
  mark_as_advanced(INSTALL_SYNC_LOGFILE_COMMAND)
  if(INSTALL_SYNC_LOGFILE_COMMAND)
    configure_file(sync-logfile.sh ${PROJECT_BINARY_DIR}/bin/choreonoid-sync-logfile COPYONLY)
  endif()
endif()

=== sample/AGXDynamics/CMakeLists.txt ===
if(NOT (BUILD_AGX_DYNAMICS_PLUGIN AND ENABLE_GUI))
  return()
endif()

set(models
  BreachingPlate.body
  LockedDoor.body
  agxMaterialSample.body
  agxWireSample.body
  FireHose.body
  agxMagneticJoint.body
  agxValve.body
  vmark.body
  )

if(UNIX)
  add_custom_target(
    symlink_to_agx_samples ALL
    COMMAND ${CMAKE_COMMAND} -E create_symlink
    ${CMAKE_CURRENT_SOURCE_DIR} ${CNOID_BINARY_SHARE_DIR}/agx)
endif()

install(FILES ${models} DESTINATION ${CNOID_SHARE_SUBDIR}/agx)

install(FILES
  AizuSpiderNA.cnoid
  AizuSpiderSA.cnoid
  AizuSpiderDA.cnoid
  DoubleArmV7A.cnoid
  AgxTank.cnoid
  ConvexDecomposition.cnoid
  LockedDoor.cnoid
  agxMagneticJoint.cnoid
  agxValve.cnoid
  FireHose.cnoid
  agxBreaching.cnoid
  agxMaterialSample.cnoid agxWireSample.cnoid
  DESTINATION ${CNOID_SHARE_SUBDIR}/agx)

=== debian/changelog ===
choreonoid (2.3.0-1) unstable; urgency=medium

  * New upstream release

 -- Shin'ichiro Nakaoka <s.nakaoka@gmail.com>  Wed, 04 Sep 2025 12:00:00 +0900

=== misc/ci-scripts/debian/changelog ===
choreonoid (1.6.0+dfsg-6.1ubuntu1) UNRELEASED; urgency=medium

  * Bump version to 1.6

 -- Fumio KANEHIRO <f-kanehiro@aist.go.jp>  Tue, 16 Aug 2016 13:03:09 +0900

choreonoid (1.5.0+dfsg-6.1ubuntu1) UNRELEASED; urgency=medium

  * Bump version to 1.5

 -- Yosuke Matsusaka <yosuke.matsusaka@gmail.com>  Tue, 20 Jan 2015 15:27:56 +0900

choreonoid (1.1.0+dfsg-6.1build1) utopic; urgency=high

  * No change rebuild against boost1.55.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 29 Apr 2014 22:10:37 +0100

choreonoid (1.1.0+dfsg-6.1) unstable; urgency=low

  * Non-maintainer upload.  Closes: #718377.
  * Install binary and libraries also when CMAKE_BUILD_TYPE=None,
    as used by new dh.  Closes: #735891.

 -- Rebecca Palmer <R.Palmer@bham.ac.uk>  Sun, 02 Feb 2014 22:23:06 +0000

choreonoid (1.1.0+dfsg-6) unstable; urgency=low

  * Remove debian/libcnoid1.symbols (Closes: #708991, #713355)
  * Add patch to fix OpenScene Graph compilation issues
    (Closes: #719387, #719387)

 -- Thomas Moulard <thomas.moulard@gmail.com>  Wed, 25 Sep 2013 14:36:11 +0900

choreonoid (1.1.0+dfsg-5) unstable; urgency=low

  * Fix patch fixing opcode portability issue (Closes: #711003).
  * Fix patch porting to Boost.Filesystem v3.
  * Update symbols for amd64, i386, kfreebsd-i386 and kfreebsd-amd64
    architectures.
  * Add autopkgtest support and simple test case.

 -- Thomas Moulard <thomas.moulard@gmail.com>  Thu, 13 Jun 2013 13:46:59 +0900

choreonoid (1.1.0+dfsg-4) unstable; urgency=low

  * Add patch to use Boost Filesystem v3 to fix compilation on Ubuntu.
  * Add patch to fix opcode portability issue (Closes: #711003).
  * Update symbols for non-amd64 architectures (Closes: #708991).
  * debian/changelog: Refer to git.debian.org in Vcs-* fields.

 -- Thomas Moulard <thomas.moulard@gmail.com>  Wed, 29 May 2013 17:18:35 +0900

choreonoid (1.1.0+dfsg-3) unstable; urgency=low

  * Update symbols for amd64 armhf i386 kfreebsd-amd64
    kfreebsd-i386 mipsel powerpc s390 sparc architectures (Closes: #708991).

 -- Thomas Moulard <thomas.moulard@gmail.com>  Sun, 26 May 2013 21:36:56 +0900

choreonoid (1.1.0+dfsg-2) unstable; urgency=low

  * Fix section. Initial upload was put in contrib/ by mistake.
  * Update symbols using pkgkde-getbuildlogs and pkgkde-symbolshelper.
  * Install pkg-config files in lib/arch (Closes: #708964).
  * Add debian/menu file.
  * Install desktop file and associated icons (png and svg files).

 -- Thomas Moulard <thomas.moulard@gmail.com>  Mon, 20 May 2013 12:52:05 +0900

choreonoid (1.1.0+dfsg-1) unstable; urgency=low

  * Add man page for choreonoid binary.
  * Add desktop entry for choreonoid binary.
  * Add lintian override file for choreonoid package.
  * Import new upstream version 1.1.0 (closes: #695190).

 -- Thomas Moulard <thomas.moulard@gmail.com>  Tue, 20 Nov 2012 15:21:16 +0900

=== debian/control ===
Source: choreonoid
Section: science
Priority: optional
Maintainer: Shin'ichiro Nakaoka <s.nakaoka@gmail.com>
Build-Depends: debhelper-compat (= 13),
               cmake,
               cmake-curses-gui,
               libeigen3-dev,
               uuid-dev,
               libxfixes-dev,
               libyaml-dev,
               libfmt-dev,
               gettext,
               zlib1g-dev,
               libzip-dev,
               libjpeg-dev,
               libpng-dev,
               libfreetype-dev,
               qt6-base-dev,
               libqt6opengl6-dev,
               qt6-svg-dev | libqt6svg6-dev,
               qt6-translations-l10n | qt6-l10n-tools,
               libglu1-mesa-dev,
               python3-dev,
               python3-numpy,
               libassimp-dev,
               libode-dev,
               libfcl-dev,
               libpulse-dev,
               libsndfile1-dev,
               libgstreamer1.0-dev,
               libgstreamer-plugins-base1.0-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev
Standards-Version: 4.6.2
Homepage: https://choreonoid.org/
Vcs-Browser: https://github.com/choreonoid/choreonoid
Vcs-Git: https://github.com/choreonoid/choreonoid.git

Package: choreonoid
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	 cmake,
         cmake-curses-gui,
         libeigen3-dev,
         libfmt-dev,
         gettext,
	 qt6-base-dev,
         libqt6opengl6-dev,
         qt6-svg-dev | libqt6svg6-dev,
         qt6-translations-l10n | qt6-l10n-tools,
	 qt6-qpa-plugins,
         libglu1-mesa-dev,
         python3,
         python3-numpy,
         python3-dev
Recommends: python3-yaml
Description: Integrated robotics GUI environment
 Choreonoid is an open-source, lightweight, and extensible integrated
 graphical framework for robot development. It provides model visualization,
 dynamics simulation, choreographing, and various robot development tools.

=== misc/ci-scripts/debian/control ===
Source: choreonoid%VERSION%
Priority: extra
Maintainer: Fumio KANEHIRO <f-kanehiro@aist.go.jp>
Build-Depends: debhelper (>= 9), cmake,
	       doxygen, doxygen-latex, graphviz,
	       pkg-kde-tools (>= 0.6),
	       libboost-all-dev,
	       libeigen3-dev,
	       libz-dev,
	       libjpeg-dev,
	       libpng-dev,
	       libglew-dev,
	       libxfixes-dev,
	       libyaml-dev,
	       libqt4-opengl-dev,
	       qt4-dev-tools,
	       qt4-qtconfig,
	       qtbase5-dev,
	       libqt5opengl5-dev,
	       libqt5x11extras5-dev,
	       libode-dev,
	       libomniorb4-dev,
	       libcos4-dev,
	       omniidl,
	       omniorb-nameserver,
	       python-omniorb,
	       omniidl-python,
	       python2.7-dev,
	       python3-dev,
	       uuid-dev,
	       openrtm-aist,
	       openrtm-aist-dev,
	       gettext
Standards-Version: 3.9.4
Section: science
Homepage: http://choreonoid.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/choreonoid.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/choreonoid.git
XS-Testsuite: autopkgtest

Package: choreonoid%VERSION%
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Suggests: choreonoid%VERSION%-doc
Multi-Arch: foreign
Description: Integrated robotics GUI environment
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.

Package: choreonoid%VERSION%-dev
Architecture: any
Section: libdevel
Depends: choreonoid%VERSION% (= ${binary:Version}), ${misc:Depends},
	 libboost-all-dev,
	 libeigen3-dev,
	 libz-dev,
	 libjpeg-dev,
	 libpng-dev,
	 libglew-dev,
	 libyaml-dev,
	 libqt4-opengl-dev,
	 pkg-config
Multi-Arch: same
Description: Integrated robotics GUI environment - development files
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package gathers header files required to compile Choreonoid.

Package: choreonoid%VERSION%-openrtm-plugin
Architecture: any
Section: libs
Depends: choreonoid%VERSION% (= ${binary:Version}),
	 ${shlibs:Depends}, ${misc:Depends},
	 openrtm-aist
Multi-Arch: same
Description: Integrated robotics GUI environment - OpenRTM Plugin
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package provides OpenRTM Plugin for Choreonoid.

Package: choreonoid%VERSION%-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Integrated robotics GUI environment - documentation
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package gathers choreonoid documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Get the architecture for build directory naming
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# Disable Debian's automatic LTO flags (both -flto=auto and -ffat-lto-objects)
# Choreonoid manages LTO internally via ENABLE_LTO=ON
export DEB_BUILD_MAINT_OPTIONS = optimize=-lto

%:
	dh $@ --buildsystem=cmake --builddirectory=obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	dh_auto_configure --builddirectory=obj-$(DEB_HOST_GNU_TYPE) -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DENABLE_INSTALL_RPATH=OFF \
		-DENABLE_LTO=ON \
		-DBUILD_CHOREONOID_INFO_COMMAND=ON \
		-DBUILD_FCL_PLUGIN=ON \
		-DBUILD_ODE_PLUGIN=ON \
		-DBUILD_LIVOX_MID360_PLUGIN=ON \
		-DBUILD_GL_CAMERA_EFFECT_PLUGIN=ON \
		-DBUILD_SCENE_EFFECTS_PLUGIN=ON \
		-DBUILD_POSE_SEQ_PLUGIN=ON \
		-DBUILD_BALANCER_PLUGIN=ON \
		-DBUILD_MULTICOPTER_PLUGIN=ON \
		-DBUILD_FFMPEG_PLUGIN=ON \
		-DBUILD_MEDIA_PLUGIN=ON \
		-DBUILD_MOCAP_PLUGIN=ON \
		-DBUILD_HRP4C_HANDLER=ON \
		-DBUILD_SUBMERSIBLE_SAMPLE=ON

=== misc/ci-scripts/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Hardening.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie,+fortify

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

.PHONY: override_dh_auto_clean		\
	override_dh_auto_configure	\
	override_dh_auto_build-indep

override_dh_auto_clean:
	dh_auto_clean
	rm -f Doxyfile				\
	      src/Base/gettext.h 		\
	      src/BodyPlugin/gettext.h 		\
	      src/PoseSeqPlugin/gettext.h 	\
	      src/Util/Config.h
	rm -Rf html

override_dh_auto_configure:
	dh_auto_configure --				\
		-DCMAKE_BUILD_TYPE=Release		\
		-DINSTALL_SDK:BOOL=TRUE			\
		-DINSTALL_DEPENDENCIES:BOOL=TRUE	\
		-DCNOID_ENABLE_GETTEXT:BOOL=TRUE	\
		-DUSE_EXTERNAL_EIGEN:BOOL=TRUE		\
		-DUSE_EXTERNAL_YAML:BOOL=TRUE		\
		-DENABLE_CORBA:BOOL=TRUE		\
		-DBUILD_CORBA_PLUGIN:BOOL=TRUE		\
		-DBUILD_OPENRTM_PLUGIN:BOOL=TRUE	\
		-DBUILD_GROBOT_PLUGIN:BOOL=TRUE		\
		-DBUILD_ASSIMP_PLUGIN:BOOL=FALSE	\
		-DBUILD_PYTHON_PLUGIN:BOOL=TRUE		\
		-DOPENRTM_DIR=/usr

override_dh_auto_build-indep:
	doxygen Doxyfile # Generate documentation.

override_dh_auto_install:
	dh_auto_install -- # Install files in prefix.
	# Install IDL related headers
	mkdir -p debian/choreonoid%VERSION%-dev/usr/include/choreonoid-1.7/cnoid
	cp -r include/cnoid/corba debian/choreonoid%VERSION%-dev/usr/include/choreonoid-1.7/cnoid
	# Install desktop file
	mkdir -p debian/choreonoid%VERSION%/usr/share/applications/
	install -m 644 ./debian/choreonoid.desktop \
	 debian/choreonoid%VERSION%/usr/share/applications/
	# Install icons.
	mkdir -p debian/choreonoid%VERSION%/usr/share/icons/hicolor/scalable/apps/
	install -m 644 ./src/Choreonoid/icon/choreonoid.svg \
	 debian/choreonoid%VERSION%/usr/share/icons/hicolor/scalable/apps/choreonoid.svg
	for s in 16 24 32 48 64 256; do \
	 mkdir -p "debian/choreonoid%VERSION%/usr/share/icons/hicolor/$$s""x$$s/apps/"; \
	 install -m 644 "./src/Choreonoid/icon/choreonoid$$s.png" \
	  "debian/choreonoid%VERSION%/usr/share/icons/hicolor/$$s""x$$s/apps/choreonoid.png"; \
	done

# Files specified using wildcard in choreonoid.install contain files related
# to OpenRTM.  If you list full filenames in choreonoid.install, this file
# need to be fix each time build configuration is changed.  By removing files
# specified in choreonoid-openrtm-plugin.install from the install directory
# for choreonoid package here, reduce theneed to fix choreonoid.install.
override_dh_install:
	dh_install
	rm -f $$(cat debian/choreonoid%VERSION%-openrtm-plugin.install | \
		sed -e 's/^\(.\+\)$$/debian\/choreonoid%VERSION%\/\1/')

%:
	dh  $@ --parallel --with pkgkde-symbolshelper
